var $ = document.getElementById.bind(document);
var website = "https://www.srware.net/forum/viewforum.php?f=21";
var latestStable, latestIronStable, downloadURL = false;
var updateStartup, updateHourly, officialStable, stableMismatch;
var currentVer = window.navigator.userAgent.match(/Chrome\/([\d.]+)/)[1];

chrome.storage.sync.get(['updateStartup', 'updateHourly'], function(items) {
    updateStartup = (items.updateStartup) ? items.updateStartup : true;
    updateHourly = (items.updateHourly) ? items.updateHourly : false;
    init();
});

chrome.runtime.onMessage.addListener(
    function(request, sender, sendResponse) {
        var errorMsg = request.errorMsg || false;
        latestIronStable = request.freesmug || latestIronStable;
        downloadURL = request.updateURL || downloadURL;

        if (latestIronStable) {
            $('loadingFreesmug').style.display = "none";
            $('freesmugVersion').innerHTML = latestIronStable;
        }
        if (errorMsg) {
            $('loadingFreesmug').style.display = "none";
            $('freesmugVersion').innerHTML = errorMsg;
            if ($('sforge')) {
                $('sforge').addEventListener('click', function() { window.open("https://www.srware.net/forum/viewforum.php?f=21") });
            }
        }

        if (latestIronStable && downloadURL) {
            matchVersion(latestIronStable, downloadURL);
        }
    }
);

function init() {
    chrome.runtime.sendMessage({ action: "getIronVersion" }, function(response) {
        if (response.errorMsg) {
            $('loadingFreesmug').style.display = "none";
            $('freesmugVersion').innerHTML = response.errorMsg;
        } else {
            latestIronStable = response.freesmug;
            downloadURL = response.updateURL;

            if (latestIronStable) {
                $('loadingFreesmug').style.display = "none";
                $('freesmugVersion').innerHTML = latestIronStable;
                matchVersion(latestIronStable, downloadURL);
            }
        }
    });

    if (officialStable) {
        // $('stable').style.visibility = "visible";
        $('stable').style.display = 'block';
    }

    setTimeout(function() {
        $('installedLabel').innerText = currentVer;
    }, 400);
}

function matchVersion(version, link) {
    if (link) {
        var update = false;
        current = currentVer.split('.');
        version = version.split('.');

        version.every(function(c, i, a) {
            if (parseFloat(current[i]) > parseFloat(version[i])) {
                return false; // Break loop when current version segment is higher
            } else if (parseFloat(current[i]) < parseFloat(version[i])) {
                update = true;
                return false;
            }
            return true;
        });

        if (update) {
            chrome.action.setIcon({ path: 'images/update.png' });
            $('installedLabel').setAttribute("style", "color: #ed1d0b; font-weight: none");
            $('freesmugVersion').setAttribute("style", "color: #4f9906; font-weight: none");
            $('updateMsg').setAttribute("style", "color: #ed1d0b; font-weight: none");
            $('websiteBtn').addEventListener('click', function() { window.open(website) });
            $('downloadBtn').addEventListener('click', function() { window.open(link) });
            document.body.style.height = "150px";
            resize = function() {
                var limit = (officialStable) ? 170 : 160;
                setTimeout(function() {
                    document.body.style.height = (parseFloat(document.body.style.height) + 5) + "px";
                    if (parseFloat(document.body.style.height) < limit) {
                        resize();
                    } else {
                        $('updateMsg').innerHTML = 'Your Iron version is out of date';
                        $('download').style.display = "block";
                    }
                }, 50);
            }
            resize();
        } else {
            chrome.action.setIcon({ path: 'images/popup.png' });
            ['updateMsg', 'installedLabel', 'freesmugVersion'].forEach(function(s) {
                $(s).setAttribute('style', 'color:#4f9906 ;');
            });
            setTimeout(function() {
                $('updateMsg').innerText = "You're up to date!";
            }, 400);
        }
    }
}

document.addEventListener('DOMContentLoaded', function() {
    $('banner').addEventListener('click', function() { window.open("https://www.srware.net/en/iron") });
    $('options').addEventListener('click', function() { chrome.runtime.openOptionsPage(); });
});
